/*
	***** Thanks *****
	ELet's HSP! / Kpan (http://lhsp.s206.xrea.com/)
*/

#include "user32.as"

#ifndef __OBJECTX__
#module __OBJECTX__

#const ES_RIGHT			0x00000002
#const ES_NUMBER		0x00002000
#const GWL_STYLE		0xFFFFFFF0
#const UDS_WRAP			0x00000001
#const UDS_SETBUDDYINT	0x00000002
#const UDS_ALIGNRIGHT	0x00000004
#const UDS_ALIGNLEFT	0x00000008
#const UDS_AUTOBUDDY	0x00000010
#const UDS_ARROWKEYS	0x00000020
#const UDS_HORZ			0x00000040
#const UDS_NOTHOUSANDS	0x00000080
#const UDS_HOTTRACK		0x00000100
#const UDM_SETRANGE		0x00000465
#const UDM_SETPOS		0x00000467

#deffunc updown var _value, int _width, int _height, int _min, int _max
/*
	Abv_ERg[쐬
*/
	i = limit(_value, _min, _max)
	input _value, _width, _height : ret = stat
	handle = objinfo_hwnd(ret)
	GetWindowLong handle, GWL_STYLE
	SetWindowLong handle, GWL_STYLE, stat | ES_RIGHT | ES_NUMBER
	winobj "msctls_updown32", "", 0, 0x50000012 | UDS_ALIGNRIGHT | UDS_ARROWKEYS | UDS_NOTHOUSANDS
	handle = objinfo_hwnd(stat)
	sendmsg handle, UDM_SETRANGE, 1, _max & 0xffff | (_min << 16)
	sendmsg handle, UDM_SETPOS, 1, i
	return ret

#const TBM_GETPOS		0x00000400
#const TBM_GETRANGEMIN	0x00000401
#const TBM_GETRANGEMAX	0x00000402
#const TBM_SETPOS		0x00000405
#const TBM_SETRANGE		0x00000406
#const WM_HSCROLL		0x00000114

#deffunc trackbar_set int _handle, int _cur, int _min, int _max
/*
	hbNo[̏ݒ
*/
	sendmsg _handle, TBM_SETRANGE, 1, _min & 0xffff | (_max << 16)
	sendmsg _handle, TBM_SETPOS, 1, _cur
	return

#defcfunc trackbar_get int _handle, int _type
/*
	hbNo[̏擾
*/
	if (_type = 0){
		sendmsg _handle, TBM_GETPOS
	}else:if (_type = 1){
		sendmsg _handle, TBM_GETRANGEMIN
	}else{
		sendmsg _handle, TBM_GETRANGEMAX
	}
	return stat

#deffunc trackbar int _width, int _height, int _cur, int _min, int _max
/*
	gbNo[쐬
*/
	if (flag = 0){
		oncmd gosub *OnTrackbarChanges, WM_HSCROLL
		if (vartype(userproc) != 1){
			userproc = *Void
		}
		flag = 1
	}
	winobj "msctls_trackbar32", "", 0, 0x50000000, _width, _height
	handle = objinfo_hwnd(stat)
	trackbar_set handle, _cur, _min, _max
	return handle

*Void
	return

*OnTrackbarChanges
	handle = lparam
	position = trackbar_get(handle)
	gosub userproc
	return

#define global trackbar_proc		userproc@__OBJECTX__
#define global trackbar_handle		handle@__OBJECTX__
#define global trackbar_position	position@__OBJECTX__

#global	// __OBJECTX__
#endif	// __OBJECTX__
