/*
	XML.as 1.05
*/

#ifndef __HTXML__
#module __HTXML__

#const MODE_READ	1	// ǂݍ݃[h
#const MODE_WRITE	2	// ݃[h

#const TYPE_BGNTAG	1	// Jn^O
#const TYPE_PNAME	2	// 
#const TYPE_PVALUE	3	// l
#const TYPE_ENDTAG	4	// I^O
#const TYPE_VALUE	5	// e

#const global XMLR_BGNTAG		1	// Jn^O
#const global XMLR_ATTRIBUTE	2	// 
#const global XMLR_ENDTAG		3	// I^O

#const TEMPSIZE	1024	// ꎞobt@̃TCY

#defcfunc IsWideChar int code
	// 2oCg̔
	if ((code >= 129) & (code <= 159)) | ((code >= 224) & (code <= 252)){
		return 1
	}
	return 0

#defcfunc IsInvalidChar int code
	// ȕ̔
	if ((code >= 129) & (code <= 159)) | ((code >= 224) & (code <= 252)) | ((code >= 'A') & (code <= 'Z')) | ((code >= 'a') & (code <= 'z')) | ((code >= '0') & (code <= '9')) | (code = '.') | (code = '_') | (code = '-'){
		return 0
	}
	return 1

#defcfunc DockPath str stra, str strb
	// pXq
	s = stra
	n = strlen(s)
	repeat 
		if (cnt >= n) : break
		c = peek(s, cnt)
		if (IsWideChar(c)){
			continue cnt+2
		}
	loop
	if (c = '\\'){
		ref = "" + stra + strb
	}else{
		ref = "" + stra + "\\" + strb
	}
	return ref

#deffunc XML_Read var name, var value, var path
	// f[^ǂݍ
	if (nMode != MODE_READ){
		return 0	// ǂݍ݃[hł͂Ȃ
	}
	name = ""
	value = ""
	path = ""
	nRet = 0
	repeat
		if (nRet){
			// lԂ
			repeat nLevel - (nRet = XMLR_BGNTAG)
				if (cnt = 0){
					path += sTags(cnt+1)
				}else{
					path += "." + sTags(cnt+1)
				}
			loop
			break
		}
		if (nRead > nLength) : break
		nCode = peek(sData, nRead) : nRead++
		// sԍ
		if (nCode = 13){
			nLine++
		}
		// GXP[v
		if (nType = TYPE_PVALUE) | (nType = TYPE_VALUE){
			if (nCode = '&'){
				p = instr(sData, nRead, ";")
				if (p > -1) & (p < 8){
					s = strmid(sData, nRead, p)
					if (nWrite < TEMPSIZE){
						switch s
						case "amp"
							poke sTemp, nWrite, '&' : nWrite++
							swbreak
						case "lt"
							poke sTemp, nWrite, '<' : nWrite++
							swbreak
						case "gt"
							poke sTemp, nWrite, '>' : nWrite++
							swbreak
						case "nbsp"
							poke sTemp, nWrite, ' ' : nWrite++
							swbreak
						case "quot"
							poke sTemp, nWrite, '"' : nWrite++
							swbreak
						swend
					}
					nRead += p + 1
				}
				continue
			}
		}

		if (nType > 0) & (nType < TYPE_VALUE){
			// NH[e[V
			if (nCode = '"'){
				bQuot = bQuot ^ 1
				if (bQuot){
					continue
				}
			}
			if (bQuot = 0){
				if (IsInvalidChar(nCode)){
					// ȕ`FbN
					if (nType = TYPE_BGNTAG){
						if (nCode != 32) & (nCode != '/') & (nCode != '>'){
							nRet = -1
							break
						}
					}else:if (nType = TYPE_PNAME){
						if (nCode != 32) & (nCode != '=') & (nCode != '/')& (nCode != '>'){
							nRet = -1
							break
						}
					}
					// ^O̔
					if (nCode = '/'){
						if (peek(sData, nRead) != '>'){
							nRet = -1
							break
						}else{
							nType = TYPE_ENDTAG
							sTemp = sTags(nLevel)
							nWrite = strlen(sTemp)
						}
					}
					// f[^
					if (nWrite > 0) | (nCode = '"'){
						poke sTemp, nWrite, 0 : nWrite = 0
						switch nType
						case TYPE_BGNTAG	// Jn^O
							nLevel++
							sTags(nLevel) = sTemp
							name = sTemp
							nType = TYPE_PNAME
							nRet = XMLR_BGNTAG
							swbreak

						case TYPE_PNAME		// 
							name = sTemp
							nType = TYPE_PVALUE
							swbreak

						case TYPE_PVALUE	// l
							value = sTemp
							nType = TYPE_PNAME
							nRet = XMLR_ATTRIBUTE
							swbreak

						case TYPE_ENDTAG	// I^O
							if (sTemp != sTags(nLevel)){
								nRet = -1
								break
							}
							nLevel--
							name = sTemp
							nType = 0
							nRet = XMLR_ENDTAG
							swbreak
						swend
					}
					// ^CvύX
					if (nCode = '='){
						nType = TYPE_PVALUE
					}
					if (nCode = '>'){
						if (nType = TYPE_PNAME){
							nType = TYPE_VALUE
						}else{
							nType = 0
						}
					}
					continue
				}
			}
		}else{
			// ^O
			if (nCode = '<'){
				// ^O̕擾
				if (nType = TYPE_VALUE){
					if (pSpace){
						nWrite = pSpace
						pSpace = 0
					}
					poke sTemp, nWrite, 0 : nWrite = 0
					value = sTemp
				}
				nCode = peek(sData, nRead)
				// I^OEXML錾ERg
				if (nCode = '/') | (nCode = '?') | (nCode = '!'){
					if (nCode = '/'){
						nType = TYPE_ENDTAG
					}else{
						// RgE錾XLbv
						if (peek(sData, nRead + 1) = '-') & (peek(sData, nRead + 2) = '-'){
							p = instr(sData, nRead, "-->")
							if (p = -1){
								nRet = -1
								break
							}
							nRead += p + 3
						}else{
							p = instr(sData, nRead, ">")
							if (p = -1){
								nRet = -1
								break
							}
							nRead += p + 1
						}
						continue
					}
					nRead++
				}else{
					nType = TYPE_BGNTAG
				}
				// ȕ`FbN
				if (IsInvalidChar(peek(sData, nRead))){
					nRet = -1
					break
				}
				continue
			}
			// Xy[X
			if (nCode <= 32){
				if (nWrite = 0){
					continue
				}else{
					if (pSpace = 0){
						pSpace = nWrite
					}
				}
			}else{
				pSpace = 0
			}
		}
		// obt@ɏ
		if (nType){
			if (nWrite < TEMPSIZE){
				poke sTemp, nWrite, nCode : nWrite++
			}
			if (IsWideChar(nCode)){
				if (nWrite < TEMPSIZE){
					poke sTemp, nWrite, peek(sData, nRead) : nWrite++
				}
				nRead++
			}
		}
	loop
	return nRet

#deffunc XML_Open str filename, int mode
	// t@CJ
	sFileName = filename	// t@C
	sdim sData, 65536		// XMLf[^
	sdim sTemp, TEMPSIZE	// ꎞobt@
	sdim sTags, 64, 16		// ^O
	nLevel = 0	// Kwx
	nLength = 0	// f[^
	nRead = 0	// peekʒu
	nWrite = 0	// pokeʒu
	pSpace = 0	// Xy[Xp
	nType = 0	// 
	bQuot = 0	// NH[e[V
	bClose = 0	// ^O
	nFlag = 0	// ėptO
	nLine = 1	// s
	nRet = 0	// ^[
	nMode = 0	// 샂[h
	if (mode = 0){
		// ǂݍ
		if (instr(sFileName, 0, ":") = -1){
			sFileName = dockpath(dir_cur, sFileName)	// tpX
		}
		exist sFileName
		if (strsize > -1){
			sdim sData, strsize + 64	// 傫߂Ɋm
			notesel sData
			noteload sFileName
			noteunsel
			nLength = strlen(sData)
			nMode = MODE_READ
			// \`FbN
			sdim dammy, 256
			repeat
				XML_Read dammy, dammy, dammy
				if (stat <= 0){
					if (stat = -1){
						nMode = 0	// G[
						nRet = -1
					}
					break
				}
			loop
			dim dammy, 1
			if (nMode) : nRet = 1 : else : nRet = -1
		}else{
			nRet = 0
		}
	}else{
		// 
		sData = "<?xml version=\"1.0\" encoding=\"shift_jis\"?>\n"
		nMode = MODE_WRITE
		bClose = 1
		nFlag = 1
		nRet = 1
	}
	return nRet

#deffunc _XML_Reader str keyname, var name, var value, var path, int offset
	// XMLf[^擾
	if (nMode != MODE_READ){
		return 0	// ǂݍ݃[hł͂Ȃ
	}
	mref stt, 64 : stt = 0 : gosub userproc	// [U[Ă()

	nRead = offset	// ǂݏoʒu
	if (offset = 0){
		nLevel = 0	// Kwx
	}
	nFlag = 0		// L[tO
	if (keyname = "") : nFlag = 1
	repeat
		xml_read name, value, path : type = stat
		if (type > 0){
			if (nFlag = 0){
				// tOEI
				a = XMLR_BGNTAG
				gosub *XMLReader_PathCmp
				nFlag = stat
			}
			if (nFlag){
				gosub userproc	// [U[Ă
				// tOEIt
				a = XMLR_ENDTAG
				gosub *XMLReader_PathCmp
				nFlag = (stat = 0)
				if (nFlag = 0) : break
			}
		}else{
			nRead = 0	// I
			break
		}
	loop
	return nRead

*XMLReader_PathCmp
	// pX`FbN
	f = 0
	if (keyname != ""){
		if (type = a){
			if (path != ""){
				if (path + "." + name = keyname){
					f = 1
				}
			}else{
				if (name = keyname){
					f = 1
				}
			}
		}
	}
	return f

#define global XML_Reader(%1,%2,%3,%4,%5,%6) userproc@__HTXML__=%6 : _XML_Reader %1,%2,%3,%4,%5

#deffunc XML_Write str _name, str _value, int _type
	// f[^
	if (nMode != MODE_WRITE){
		return 0	// ݃[hł͂Ȃ
	}
	name = _name
	value = _value
	type = _type
	nRet = 1

	// ȕ`FbN
	repeat strlen(name)
		nCode = peek(name, cnt)
		if (IsInvalidChar(nCode)){
			nRet = -1
			break
		}
		if (IsWideChar(nCode)){
			continue cnt + 2
		}
	loop

	// GXP[v
	sdim sTemp, strlen(value) * 6
	nWrite = 0
	repeat strlen(value)
		nCode = peek(value, cnt)
		if (IsWideChar(nCode)){
			poke sTemp, nWrite, nCode : nWrite++
			poke sTemp, nWrite, peek(value, cnt+1) : nWrite++
			continue cnt + 2
		}else{
			switch nCode
			case '&'
				poke sTemp, nWrite, "&amp;" : nWrite += strsize
				swbreak
			case '<'
				poke sTemp, nWrite, "&lt;" : nWrite += strsize
				swbreak
			case '>'
				poke sTemp, nWrite, "&gt;" : nWrite += strsize
				swbreak
			case '"'
				poke sTemp, nWrite, "&quot;" : nWrite += strsize
				swbreak
			default
				poke sTemp, nWrite, nCode : nWrite++
			swend
		}
	loop
	poke sTemp, nWrite, 0 : nWrite = 0
	value = sTemp

	// ݏ
	if (nRet > -1){
		switch type
		case XMLR_BGNTAG	// Jn^O
			gosub *XML_Write_Indent
			sData += "<" + name
			if (value != ""){
				sData += ">" + value + "</" + name + ">\n"
				bClose = 1
				nFlag = 0
			}else{
				nLevel++
				sTags(nLevel) = name
				bClose = 0
				nFlag = 1
			}
			swbreak
		case XMLR_ATTRIBUTE	// 
			if (nLevel > 0) & (nFlag > -1){
				sData += " " + name + "=\"" + value + "\""
			}
			swbreak
		case XMLR_ENDTAG	// I^O
			if (bClose = 0) & (value = "") & (nFlag = 1){
				sData += " />\n"	// ^Oɂ
			}else{
				gosub *XML_Write_Indent
				if (sTags(nLevel) = name){
					sData += "" + value + "</" + name + ">\n"
				}else{
					nRet = -1	// Jn^OƏI^OvȂ
				}
			}
			if (nRet != -1){
				nLevel--
				bClose = 1
				nFlag = -1
			}
			swbreak
		swend
	}
	if (nRet = -1){
		nMode = 0	// G[Œf
	}
	return nRet

*XML_Write_Indent
	// Cfg
	if (bClose = 0){
		bClose = 1
		sData += ">\n"	// ^O
	}
	if (nLevel - (type = XMLR_ENDTAG) > 0){
		repeat nLevel - (type = XMLR_ENDTAG)
			sData += " "	// Cfg
		loop
	}
	return

#deffunc XML_Save
	// t@Cۑ
	if (nMode = MODE_WRITE) & (sFileName != "") & (nLevel = 0){
		notesel sData
		notesave sFileName
		noteunsel
		return 1
	}
	return 0

#deffunc XML_Close
	// t@C
	sdim sData, 64
	sdim sTemp, 64
	sdim sTags, 64
	sdim sFileName, 64
	nMode = 0
	return

#global	// __HTXML__
#endif	// __HTXML__
