
#include "user32.as"
#include "clist.as"

#module __CONTROLS__

#deffunc GetInfo_Initialize
/*
	
*/
	#define global MX nPoint
	#define global MY nPoint(1)

	#const WM_MOUSEMOVE		0x00000200
	#const WM_LBUTTONDOWN	0x00000201
	#const WM_LBUTTONUP		0x00000202
	#const WM_MOUSELEAVE	0x000002A3

	oncmd gosub *OnMouseEvent, WM_LBUTTONDOWN
	oncmd gosub *OnMouseEvent, WM_LBUTTONUP
	oncmd gosub *OnMouseEvent, WM_MOUSEMOVE
	oncmd gosub *OnMouseEvent, WM_MOUSELEAVE
	return

*OnMouseEvent
	return

#defcfunc GetInfo_SysTime
/*
	VXeoߎԂ擾
*/
	timeGetTime
	return stat

#deffunc GetInfo_MouseButton var _ref, int _btn
/*
	}EX{^̏Ԃ擾
*/
	if (_ref = -1){
		_ref = 4
	}else{
		getkey b, _btn
		if (b){
			if (_ref = 0) | (_ref = 3){
				_ref = 1
			}else{
				_ref = 2
			}
		}else{
			if (_ref = 1) | (_ref = 2) | (_ref = 4){
				_ref = 3
			}else{
				_ref = 0
			}
		}
	}
	return

#deffunc GetInfo
/*
	e擾
*/
	nPoint = ginfo_mx, ginfo_my
	nSysTime = GetInfo_SysTime()
	WindowFromPoint nPoint, nPoint(1) : hwnd_Point = stat
	GetForegroundWindow : hwnd_Fore = stat
	GetInfo_MouseButton nLeftButton, 1
	return

#deffunc Controls_Initialize int _buf
/*
	
*/
	// `揈pobt@ID
	Controls_BufferID = limit(_buf, 1, 256)

	// 擾pW[̏
	GetInfo_Initialize

	// Rg[̃p[^
	#const CONTROL_ID		0	// ID
	#const CONTROL_X		1	// ʒux
	#const CONTROL_Y		2	// ʒuy
	#const CONTROL_WIDTH	3	// 
	#const CONTROL_HEIGHT	4	// 
	#const CONTROL_MASTER	5	// }X^[ID
	#const CONTROL_FLAGS	6	// IvV
	#const CONTROL_IDWND	7	// EBhEID

	// IvV
	#const CONTROL_FLAG_DRAG		1	// hbO
	#const CONTROL_FLAG_DROP		2	// hbv
	#const CONTROL_FLAG_FORM		4	// tH[

	// CxgR[h
	#const global EVENT_INITIALIZE	0x0001	// 
	#const global EVENT_MOUSEIN		0x0010	// I
	#const global EVENT_MOUSEOUT	0x0020	// 
	#const global EVENT_HOVER		0x0040	// I
	#const global EVENT_DOWN		0x0080	// _E
	#const global EVENT_RELEASE		0x0100	// [X
	#const global EVENT_ACTIVATE	0x0200	// s
	#const global EVENT_DRAGON		0x0400	// hbO
	#const global EVENT_DROPON		0x0800	// hbv

	// Xg쐬
	cl_create xControls, 16, 8, ""
	iRoot = cl_add(xControls)

	// }X^[pxϐ
	dimtype Controls_Proc, vartype("label"), 8
	repeat 8
		Controls_Proc(cnt) = *Nothing
	loop
	dim Controls_hWnd, 32	// EBhEnh
	nCount = 0	// }X^[̐
	return

*Nothing
	return

#deffunc Controls_RegisterProcS
/*
	}X^[o^
*/
	if (vartype(userproc) = 1){
		nCount++
		Controls_Proc(nCount) = userproc
		return nCount
	}
	return 0

#deffunc Controls_Call int _id, int _event
/*
	}X^[Ăяo
*/
	if (cl_check(xControls, _id)){
		Controls_CurrentID = _id
		dim Control, 8
		memcpy Control, xControls, 32, 0, _id*4
		mref _stat, 64 : _stat = _event
		gosub Controls_Proc(xControls(_id + CONTROL_MASTER))
	}
	return

#deffunc Controls_RegisterWindow int _id, int _master, int _flags
/*
	EBhEo^
*/
	id = cl_add(xControls, iRoot, 2)
	xControls(id) = _id, 0, 0, ginfo_winx, ginfo_winy, _master, _flags, ginfo_sel
	Controls_hWnd(ginfo_sel) = hwnd
	return id

#deffunc Controls_RegisterObject int _id, int _x, int _y, int _width, int _height, int _master, int _flags, int _parent
/*
	IuWFNgo^
*/
	i = cl_add(xControls, _parent, 2)
	xControls(i) = _id, _x, _y, _width, _height, _master, _flags, xControls(_parent + CONTROL_IDWND)
	xControls(i + CONTROL_X) += xControls(_parent + CONTROL_X)
	xControls(i + CONTROL_Y) += xControls(_parent + CONTROL_Y)
	Controls_Call i, EVENT_INITIALIZE
	return i

#deffunc Controls_DeleteObject int _id
/*
	IuWFNg폜
*/
	cl_delete xControls, _id
	return stat

#deffunc Controls_SetRange int _id
/*
	L͈͂擾
*/
	id = _id
	nLeft = 0
	nTop = 0
	nRight = ginfo_dispx
	nBottom = ginfo_dispy
	repeat
		if (nLeft < xControls(id + CONTROL_X)){
			nLeft = xControls(id + CONTROL_X)
		}
		if (nTop < xControls(id + CONTROL_Y)){
			nTop = xControls(id + CONTROL_Y)
		}
		if (nRight > xControls(id + CONTROL_X) + xControls(id + CONTROL_WIDTH)){
			nRight = xControls(id + CONTROL_X) + xControls(id + CONTROL_WIDTH)
		}
		if (nBottom > xControls(id + CONTROL_Y) + xControls(id + CONTROL_HEIGHT)){
			nBottom = xControls(id + CONTROL_Y) + xControls(id + CONTROL_HEIGHT)
		}
		if ((xControls(id + CLI_PARENT) = 0) | (xControls(id + CLI_PARENT) = iRoot)){
			break
		}
		id = xControls(id + CLI_PARENT)
	loop
	return

#if 0
#deffunc Controls_BeginPaint
/*
	`揈Jn
*/
	resel = ginfo_sel
	buffer Controls_BufferID, Control(CONTROL_WIDTH), Control(CONTROL_HEIGHT)
	return

#deffunc Controls_EndPaint
/*
	`揈I
*/
	Controls_SetRange Controls_CurrentID
	xs = 0 : ys = 0
	if (Control(CONTROL_X) < nLeft){
		xd = nLeft
		xs = nLeft-Control(CONTROL_X)
	}else{
		xd = Control(CONTROL_X)
	}
	if (Control(CONTROL_Y) < nTop){
		yd = nTop
		ys = nTop-Control(CONTROL_Y)
	}else{
		yd = Control(CONTROL_Y)
	}
	if (Control(CONTROL_X)+Control(CONTROL_WIDTH) > nRight){
		cx = Control(CONTROL_WIDTH) - (Control(CONTROL_X)+Control(CONTROL_WIDTH) - nRight)
	}else{
		cx = Control(CONTROL_WIDTH)
	}
	if (Control(CONTROL_Y)+Control(CONTROL_HEIGHT) > nBottom){
		cy = Control(CONTROL_HEIGHT) - (Control(CONTROL_Y)+Control(CONTROL_HEIGHT) - nBottom)
	}else{
		cy = Control(CONTROL_HEIGHT)
	}

	gsel Control(Control_IDWND)
	redraw 0
	pos xd, yd
	gcopy Controls_BufferID, xs, ys, cx, cy
	Controls_Redraw = 1
	return
#endif

#defcfunc Controls_InRect int _id
/*
	͈̓`FbN
*/
	if (MX >= xControls(id + CONTROL_X)) & (MX < xControls(id + CONTROL_X) + xControls(id + CONTROL_WIDTH)){
		if (MY >= xControls(id + CONTROL_Y)) & (MY < xControls(id + CONTROL_Y) + xControls(id + CONTROL_HEIGHT)){
			return 1
		}
	}
	return 0

#defcfunc Controls_CheckObject int _id
/*
	IuWFNg`FbN
*/
	if (_id = 0){
		id = xControls(iRoot + CLI_CHILD)
	}else{
		id = _id
	}	
	i = 0
	repeat
		if (i = 0){
			if (hwnd_point = Controls_hWnd(xControls(id + CONTROL_IDWND))){
				i = id
				ScreenToClient Controls_hWnd(xControls(id + CONTROL_IDWND)), varptr(nPoint)
				if (Controls_InRect(id) = 0){
					i = 0
					break
				}
				continue
			}
		}else{
			if (Controls_InRect(id)){
				i = id
				if (xControls(id + CLI_CHILD)){
					id = xControls(id + CLI_CHILD)
					continue
				}else{
					break
				}
			}
		}
		id = xControls(id + CLI_NEXT)
		if (xControls(xControls(id + CLI_PARENT) + CLI_CHILD) = id){
			break
		}
	loop
	return i

#deffunc Controls_Running
/*
	Rg[̏
*/
	GetInfo
	i = 0
	if (iHover){
		i = Controls_CheckObject(iHover)
		if (i){
			Controls_SetRange i
			if (MX < nLeft) | (MX >= nRight) | (MY < nTop) | (MY >= nBottom){
				i = 0
			}
		}
	}
	if (i = 0){
		if (iHover){
			nPoint = ginfo_mx, ginfo_my
		}
		i = Controls_CheckObject()
	}
	if (i != iHover){
		Controls_Call iHover, EVENT_MOUSEOUT
		if (iRock = iHover) & (iRock > 0){
			if (xControls(iRock + CONTROL_FLAGS) & CONTROL_FLAG_DRAG){
				Controls_Call iRock, EVENT_DOWN
				bDrag = 1
			}
		}
		iHover = i
		if (iRock = 0){
			Controls_Call iHover, EVENT_MOUSEIN
		}else:if (iRock = iHover){
			Controls_Call iRock, EVENT_DOWN
		}else:if (bDrag){
			if (xControls(iHover + CONTROL_FLAGS) & CONTROL_FLAG_DROP){
				cparam = xControls(iRock)
				Controls_Call iHover, EVENT_DRAGON
			}
		}
	}else{
		Controls_Call iHover, EVENT_HOVER
	}
	if (nLeftButton = 1){
		Controls_Call iHover, EVENT_DOWN
		if (iHover){
			iRock = iHover
		}else{
			iRock = -1
		}
	}else:if (nLeftButton = 3){
		if (iRock = iHover){
			if (xControls(iHover + CONTROL_FLAGS) & CONTROL_FLAG_DRAG = 0) | (bDrag = 0){
				Controls_Call iHover, EVENT_ACTIVATE
			}
		}else{
			Controls_Call iRock, EVENT_RELEASE
		}
		Controls_Call iHover, EVENT_MOUSEIN
		if (bDrag){
			bDrag = 0
			if (xControls(iHover + CONTROL_FLAGS) & CONTROL_FLAG_DROP){
				if (iHover != iRock) & (iRock > 0){
					cparam = xControls(iRock)
					Controls_Call iHover, EVENT_DROPON
				}
			}
		}
		iRock = 0
	}
	if (Controls_Redraw){
		Controls_Redraw = 0
		redraw 1
		;gsel resel
	}
	return

#define global Controls_RegisterProc(%1) userproc@__CONTROLS__=%1 : Controls_RegisterProcS
#define global Controls_Redraw	Controls_Redraw@__CONTROLS__
#define global Control	Control@__CONTROLS__
#define global cparam	cparam@__CONTROLS__
#define global nPoint	nPoint@__CONTROLS__
#define global nSysTime		nSysTime@__CONTROLS__
#define global nLeftButton	nLeftButton@__CONTROLS__
#define global hwnd_fore	hwnd_fore@__CONTROLS__
#define global hwnd_point	hwnd_point@__CONTROLS__

#global	// __CONTROLS__
