/*
	Menu.as 1.05
*/

#include "user32.as"

#ifndef __MENU__
#module __MENU__

#const MF_GRAYED	0x00000001
#const MF_CHECKED	0x00000008
#const MF_POPUP		0x00000010
#const MF_SEPARATOR	0x00000800
#const WM_COMMAND	0x00000111

#deffunc Menu str _caption, int _flags
/*
	j[쐬
	_caption	\
	_flags		IvV
*/
	if (nMode = 0) | (nMode = -1){
		if (nMode = 0){
			hMenuList = 0	// j邽߂̃Xg
			nCount = 0		// JE^
			oncmd gosub *OnMenuCommand, WM_COMMAND
		}
		if (vartype(userProc) != 1){
			userProc = *Void	// G[h~̂ߋ̃x
		}
		hMenu = 0		// j[nhi[p
		nLevel = 0		// Kwx
		if (_caption != "popup"){
			nMode = 1
			CreateMenu	// j[쐬
		}else{
			nMode = 2
			CreatePopupMenu	// |bvAbvj[쐬
		}
		handle = stat
		nCount++
		hMenuList(nCount) = handle	// Xgɒǉ
	}else{
		CreatePopupMenu : handle = stat	// Tuj[
		AppendMenu hMenu(nLevel), MF_POPUP | _flags, handle, _caption
	}
	nLevel++
	hMenu(nLevel) = handle	// ݂̃nh
	return handle

#deffunc Item str _caption, int _id, int _flags
/*
	j[ACe쐬
	_caption	\
	_id			j[ID
	_flags		IvV
*/
	if (nLevel > 0){
		if (_caption != ""){
			AppendMenu hMenu(nLevel), _flags, _id, _caption	// ACeǉ
		}else{
			AppendMenu hMenu(nLevel), MF_SEPARATOR, _id, 0	// d؂ǉ
		}
	}
	return stat

#deffunc _Menu
/*
	j[
*/
	if (nLevel > 0){
		nLevel--
		if (nLevel = 0){
			if (nMode = 1){
				GetMenu hwnd : handle = stat
				if (handle){
					DestroyMenu handle	// ̃j[j
				}
				SetMenu hwnd, hMenu(1)	// j[EBhEɓKp
				if (stat){
					DrawMenuBar hwnd	// `
					nCount--
				}
			}
			nMode = -1
		}
	}
	return

#deffunc Popup int _handle, int _x, int _y
/*
	|bvAbvj[\
	_handle	j[nh
	_x		ʒux
	_y		ʒuy
*/
	TrackPopupMenu _handle, 2, _x, _y, 0, hwnd, 0
	return

#deffunc Menu_State int _handle, int _id, int _flags
/*
	j[̏ԂύX
	_handle	j[nh
	_id		j[ID
	_flags	j[̏(1=`FbN, 2=OC)
*/
	CheckMenuItem _handle, _id, 0
	EnableMenuItem _handle, _id, 0
	if (_flags & 1){
		CheckMenuItem _handle, _id, MF_CHECKED
	}
	if (_flags & 2){
		EnableMenuItem _handle, _id, MF_GRAYED
	}
	return

#deffunc Menu_Call int _id
/*
	j[Ăяo
*/
	mref _stat, 64 : _stat = _id
	gosub userProc	// [U[Ă	
	return

#deffunc Menu_Destroy onexit
/*
	j[j
*/
	repeat nCount, 1
		DestroyMenu hMenuList(cnt)
	loop
	return

*OnMenuCommand
/*
	j[s
*/
	menu_id = wparam & 0xffff
	mref _stat, 64 : _stat = menu_id
	gosub userProc	// [U[Ă
	return

*Void
	return

	#define global Menu_Proc	userProc@__MENU__
	#define global Menu_ID		menu_id@__MENU__

#global	// __MENU__
#endif	// __MENU__
