
#defcfunc GetParamNumber str _key, str _param
/*
	p[^ԍ擾
	_key	L[
	_param	p[^
*/
	s = _param + ","
	i = 0
	ret = 0
	repeat
		p = instr(s, i, ",")
		if (p = -1){
			ret = -1
			break
		}else{
			if (strmid(s, i, p) = _key){
				break
			}
			i += p+1
			ret++
		}
	loop
	return ret

#defcfunc GetParamName int _num, str _param
/*
	p[^擾
	_num	ԍ
	_param	p[^
*/
	s = _param + ","
	i = 0
	ret = 0
	_ref = ""
	repeat
		p = instr(s, i, ",")
		if (p = -1){
			ret = -1
			break
		}else{
			if (ret = _num){
				_ref = strmid(s, i, p)
				break
			}
			i += p+1
			ret++
		}
	loop
	return _ref

#defcfunc GetColorRef str _color
/*
	F擾
	_color	"r,g,b"`̐F
*/
	s = _color + ","
	i = 0
	c = 0
	ret = 0, 0, 0
	repeat 3
		p = instr(s, i, ",")
		if (p = -1){
			break
		}else{
			ret(c) = int(strmid(s, i, p))
			i += p+1
			c++
		}
	loop
	return (ret | (ret(1) << 8) | (ret(2) << 16))

#deffunc Import str _file, int _mode
/*
	ݒt@C̓ǂݍ
	_file	t@C
	_mode	(0=S, 1=ݒ̂)
*/
	xml_open _file
	if (stat = 1){
		if (_mode = 0){
			xml_reader "application.launcher", sName, sValue, sPath, 0, *Import_Launcher
		}
		xml_reader "application.configurations", sName, sValue, sPath, 0, *Import_Configurations
		xml_reader "application.sidework", sName, sValue, sPath, 0, *Import_SideWork
	}
	xml_close
	return

*Import_Configurations
/*
	eݒ
*/
	switch stat
	case XMLR_INITIALIZE
		nSection = 0
		swbreak

	case XMLR_BGNTAG
		if (sName = "colors"){
			nSection = 1
		}
		if (sName = "metrics"){
			nSection = 2
		}
		swbreak

	case XMLR_ATTRIBUTE
		if (nSection = 0){
			if (sName = "name"){
				id = GetParamNumber(getpath(sValue, 16), "animate,autoclose,trayicon,animateslide,mouseaction,staytime,clicktime,knocktime,animatetime,autoclosetime,autocloserange,spacelefttop,spaceleftbottom,spacerighttop,spacerightbottom,translate")
			}
			if (sName = "value"){
				if (id < 4){
					b = (getpath(sValue, 16) = "true")
					switch id
						case 0 : bAnimate = b : swbreak
						case 1 : bAutoClose = b : swbreak
						case 2 : bTrayIcon = b : swbreak
						case 3 : bAnimateSlide = b : swbreak
					swend
				}else{
					n = int(sValue)
					switch id
						case 4 : nMouseAct = n : swbreak
						case 5 : nStayTime = n : swbreak
						case 6 : nClickTime = n : swbreak
						case 7 : nKnockTime = n : swbreak
						case 8 : nAnimateTime = n : swbreak
						case 9 : nAutoCloseTime = n : swbreak
						case 10: nAutoCloseRange = n : swbreak
						case 11: nSpaceLeftTop = n : swbreak
						case 12: nSpaceLeftBottom = n : swbreak
						case 13: nSpaceRightTop = n : swbreak
						case 14: nSpaceRightBottom = n : swbreak
						case 15: nTransLate = n : swbreak
					swend
				}
			}
		}else:if (nSection = 1){
			if (sName = "name"){
				id = GetParamNumber(getpath(sValue, 16), "text,shadow,background1,background2,stripe,separator,labeltext,labelbackground,hover,down")
			}
			if (sName = "value"){
				if (id > -1){
					nColors(id) = GetColorRef(sValue)
				}
			}
		}else{
			if (sName = "name"){
				id = GetParamNumber(getpath(sValue, 16), "fontname,fontsize,width,itemminheight,itemmaxheight,separatorheight,paddingleft,paddingright,iconmargin,labelheight,stripe,gradiant,shadow,background")
			}
			if (sName = "value"){
				n = int(sValue)
				switch id
					case 0 : sFontName = sValue : swbreak
					case 1 : nFontSize = n : swbreak
					case 2 : nWidth = n : swbreak
					case 3 : nItemMinHeight = n : swbreak
					case 4 : nItemMaxHeight = n : swbreak
					case 5 : nSeparatorHeight = n : swbreak
					case 6 : nPaddingLeft = n : swbreak
					case 7 : nPaddingRight = n : swbreak
					case 8 : nIconMargin = n : swbreak
					case 9 : nLabelHeight = n : swbreak
					case 10: bStripe = (getpath(sValue, 16) = "true") : swbreak
					case 11: bGradiant = (getpath(sValue, 16) = "true") : swbreak
					case 12: bShadow = (getpath(sValue, 16) = "true") : swbreak
					case 13: sBackground = sValue : swbreak
				swend
			}
		}
		swbreak

	case XMLR_ENDTAG
		if (sName = "colors") | (sName = "metrics"){
			nSection = 0
		}
		swbreak
	swend
	return

*Import_Launcher
/*
	`EACe
*/
	switch stat
	case XMLR_INITIALIZE
		cl_create xLaunch, 32, 10, "nssssnni"
		id = cl_add(xLaunch)
		cl_set xLaunch, id, 1, "EXLAUNCHER"
		cl_set xLaunch, id, 4, "EXL3.exe"
		iRoot = id
		dim iCurrent, 8
		nLevel = 0
		iCurrent(nLevel) = id
		swbreak

	case XMLR_BGNTAG
		if (sName = "entry"){
			id = cl_add(xLaunch, iCurrent(nLevel), 2)
			nLevel++
			iCurrent(nLevel) = id
		}
		swbreak

	case XMLR_ATTRIBUTE
		p = GetParamNumber(sName, "type,name,href,param,icon,index,hotkey")
		if (p > -1){
			if (p = 0){
				cl_set xLaunch, id, 0, GetParamNumber(sValue, "group,link,separator")
			}else{
				cl_set xLaunch, id, p, sValue
			}
		}
		swbreak

	case XMLR_ENDTAG
		if (sName = "entry"){
			nLevel--
		}
		swbreak
	swend
	return

*Import_SideWork
/*
	ʒuɂ铮w
*/
	switch stat
	case XMLR_INITIALIZE
		dim nSideWork, 6
		nSideWork = 0, 1, 0, 0, 1, 0
		id = 0
		swbreak

	case XMLR_BGNTAG
		swbreak

	case XMLR_ATTRIBUTE
		if (sName = "locate"){
			id = GetParamNumber(getpath(sValue, 16), "lefttop,leftmiddle,leftbottom,righttop,rightmiddle,rightbottom")
		}
		if (sName = "target"){
			if (id > -1){
				n = 0
				if (sValue != ""){
					p = GetParamNumber(getpath(sValue, 16), ":aaaa,:latest,:root")
					if (p > -1){
						n = p
					}else{
						i = xLaunch(iRoot + CLI_CHILD)
						if (i){
							repeat
								if (strref(xLaunch(i + 1)) = sValue){
									n = i
									break
								}
								i = xLaunch(i + CLI_NEXT)
								if (xLaunch(xLaunch(i + CLI_PARENT) + CLI_CHILD) = i){
									break
								}
							loop
						}
					}
				}
				nSideWork(id) = n
			}
		}
		swbreak

	case XMLR_ENDTAG
		swbreak
	swend
	return

#defcfunc tof int _value
/*
	"true""false"Ԃ
	_value	l
*/
	if (_value){
		return "true"
	}
	return "false"

#defcfunc SetColorRef int _color
/*
	FZbg
	_color	colorref
*/
	return "" + (_color & 255) + "," + (_color >> 8 & 255) + "," + (_color >> 16 & 255)

#deffunc xml_param str _name, str _value
/*
	p[^
	_name	O
	_value	l
*/
	xml_write "param", "", 1
		xml_write "name", _name, 2
		xml_write "value", _value, 2
	xml_write "param", "", 3
	return

#deffunc Export str _file
/*
	ݒۑ
	_file	t@C
*/
	xml_open _file, 1

	xml_write "application", "", 1
		xml_write "configurations", "", 1
			xml_param "MouseAction", str(nMouseAct)
			xml_param "StayTime", str(nStayTime)
			xml_param "ClickTime", str(nClickTime)
			xml_param "KnockTime", str(nKnockTime)
			xml_param "Animate", tof(bAnimate)
			xml_param "AnimateTime", str(nAnimateTime)
			xml_param "AnimateSlide", tof(bAnimateSlide)
			xml_param "AutoClose", tof(bAutoClose)
			xml_param "AutoCloseTime", str(nAutoCloseTime)
			xml_param "AutoCloseRange", str(nAutoCloseRange)
			xml_param "TrayIcon", tof(bTrayIcon)
			xml_param "SpaceLeftTop", str(nSpaceLeftTop)
			xml_param "SpaceLeftBottom", str(nSpaceLeftBottom)
			xml_param "SpaceRightTop", str(nSpaceRightTop)
			xml_param "SpaceRightBottom", str(nSpaceRightBottom)
			xml_param "TransLate", str(nTransLate)
			xml_write "colors", "", 1
				xml_param "Text", SetColorRef(nColors(0))
				xml_param "Shadow", SetColorRef(nColors(1))
				xml_param "Background1", SetColorRef(nColors(2))
				xml_param "Background2", SetColorRef(nColors(3))
				xml_param "Stripe", SetColorRef(nColors(4))
				xml_param "Separator", SetColorRef(nColors(5))
				xml_param "LabelText", SetColorRef(nColors(6))
				xml_param "LabelBackground", SetColorRef(nColors(7))
				xml_param "Hover", SetColorRef(nColors(8))
				xml_param "Down", SetColorRef(nColors(9))
			xml_write "colors", "", 3
			xml_write "metrics", "", 1
				xml_param "FontName", str(sFontName)
				xml_param "FontSize", str(nFontSize)
				xml_param "Width", str(nWidth)
				xml_param "ItemMinHeight", str(nItemMinHeight)
				xml_param "ItemMaxHeight", str(nItemMaxHeight)
				xml_param "SeparatorHeight", str(nSeparatorHeight)
				xml_param "PaddingLeft", str(nPaddingLeft)
				xml_param "PaddingRight", str(nPaddingRight)
				xml_param "IconMargin", str(nIconMargin)
				xml_param "LabelHeight", str(nLabelHeight)
				xml_param "Stripe", tof(bStripe)
				xml_param "Gradiant", tof(bGradiant)
				xml_param "Shadow", tof(bShadow)
				xml_param "Background", str(sBackground)
			xml_write "metrics", "", 3
		xml_write "configurations", "", 3
		gosub *Export_Launcher
		xml_write "sidework", "", 1
			repeat 6
				xml_write "entry", "", 1
					xml_write "locate", GetParamName(cnt, "LeftTop,LeftMiddle,LeftBottom,RightTop,RightMiddle,RightBottom"), 2
					s = ""
					if (nSideWork(cnt) > 0){
						if (nSideWork(cnt) < 3){
							s = GetParamName(nSideWork(cnt), ",:latest,:root")
						}else{
							s = cl_get(xLaunch, nSideWork(cnt), 1)
						}
					}
					xml_write "target", s, 2
				xml_write "entry", "", 3
			loop
		xml_write "sidework", "", 3
	xml_write "application", "", 3

	xml_save
	if (stat = 0){
		dialog "ݒt@C̕ۑɎs܂B\n\n" + _file, 1, "EXLAUNCHER"
	}
	xml_close
	return

#deffunc XML_WriteItem int _id
/*
	ACẽf[^
	_id		ACeID
*/
	if (_id != iRoot){
		xml_write "entry", "", 1
	}else{
		xml_write "launcher", "", 1
	}
	f = xLaunch(_id + 0)
	if (f = 0){
		s = "group"
	}else:if (f = 1){
		s = "link"
	}else{
		s = "separator"
	}
	if (_id != iRoot){
		xml_write "type", s, 2
	}
	if (f < 2){
		xml_write "name", strref(xLaunch(_id + 1)), 2
		if (f = 1){
			xml_write "href", strref(xLaunch(_id + 2)), 2
			xml_write "param", strref(xLaunch(_id + 3)), 2
		}
		xml_write "icon", strref(xLaunch(_id + 4)), 2
		xml_write "index", str(xLaunch(_id + 5)), 2
		xml_write "hotkey", str(xLaunch(_id + 6)), 2
	}
	if (xLaunch(_id + CLI_CHILD) = 0) & (_id != iRoot){
		xml_write "entry", "", 3
	}
	return

*Export_Launcher
/*
	`EACe
*/
	xml_writeitem iRoot
	id = xLaunch(iRoot + CLI_CHILD)
	lv = 1
	if (id){
		repeat xLaunch(CLH_COUNT)
			if (xLaunch(id + CLI_CHILD)){
				xml_writeitem id
				id = xLaunch(id + CLI_CHILD)
				lv++
			}else{
				xml_writeitem id
				id = xLaunch(id + CLI_NEXT)
				repeat 1
					if (xLaunch(id + CLI_PARENT)){
						if (xLaunch(xLaunch(id + CLI_PARENT) + CLI_CHILD) = id){
							id = xLaunch(xLaunch(id + CLI_PARENT) + CLI_NEXT)
							lv--
							if (lv){
								xml_write "entry", "", 3
							}
							if (lv > 0){
								continue 0
							}
						}
					}
				loop
			}
			if (id < xLaunch(CLH_DATAHEAD)) | (lv = 0){
				break
			}
		loop
	}
	xml_write "launcher", "", 3
	return
