
#deffunc Launcher_Reload int _id, int _mode
/*
	`̕\ACeZbg
*/
	iSelect = _id
	if (cl_check(xLaunch, iSelect) = 0){
		iSelect = xLaunch(iRoot + CLI_CHILD)
	}
	if (iSelect){
		if (xLaunch(iSelect + LAUNCH_TYPE) != LAUNCH_TYPE_GROUP){
			iSelect = 0
		}
	}
	if (cl_check(xLaunch, iSelect) = 0){
		iSelect = iRoot
	}

	nCount = 0
	nSepaCount = 0
	id = xLaunch(iSelect + CLI_CHILD)
	if (id){
		repeat
			nCount++
			if (xLaunch(id + LAUNCH_TYPE) = LAUNCH_TYPE_SEPARATOR){
				nSepaCount++
			}
			id = xLaunch(id + CLI_NEXT)
			if (xLaunch(xLaunch(id + CLI_PARENT) + CLI_CHILD) = id){
				break
			}
		loop
	}
	if (nCount){
		if (nCount-nSepaCount){
			nItemHeight = (nHeight - nLabelHeight - nSepaCount * nSeparatorHeight) / (nCount - nSepaCount)
			nItemHeight = limit(nItemHeight, nItemMinHeight, nItemMaxHeight)
		}else{
			nItemHeight = nItemMaxHeight
		}
		x = 0
		y = ((nHeight - nLabelHeight - nSepaCount * nSeparatorHeight) - nItemHeight * (nCount - nSepaCount)) / 2 + (bLabelPos = 0) * nLabelHeight
		w = nWidth
		h = 0
	}else{
		nItemHeight = nItemMaxHeight
	}
	nIconSize = 32 - (16 * (nItemHeight < 32))
	Drawing_SetBlendPattern nWidth, nItemHeight

	id = xLaunch(iSelect + CLI_CHILD)
	repeat nCount
		if (xLaunch(id + LAUNCH_TYPE) = LAUNCH_TYPE_SEPARATOR){
			h = nSeparatorHeight
		}else{
			h = nItemHeight
		}
		switch _mode
		case 0
			xs = x
			ys = y
			swbreak
		case 1
			xs = x
			ys = (nDispy - nLabelHeight - nItemHeight) / 2
			swbreak
		case 2
			xs = -nWidth
			ys = (nDispy - nLabelHeight - nItemHeight) / 2
			swbreak
		case 3
			xs = nWidth
			ys = (nDispy - nLabelHeight - nItemHeight) / 2
			swbreak
		case 4
			xs = xLaunch(id + LAUNCH_X)
			ys = xLaunch(id + LAUNCH_Y)
			swbreak
		swend
		ax(cnt) = double(xs - x) / (nAnimateTime * nAnimateTime)
		ay(cnt) = double(ys - y) / (nAnimateTime * nAnimateTime)

		xLaunch(id + LAUNCH_X) = x
		xLaunch(id + LAUNCH_Y) = y
		if (xLaunch(id + LAUNCH_TYPE) = LAUNCH_TYPE_SEPARATOR){
			y += nSeparatorHeight
		}else{
			y += nItemHeight
		}
		id = xLaunch(id + CLI_NEXT)
		if (xLaunch(xLaunch(id + CLI_PARENT) + CLI_CHILD) = id){
			break
		}
	loop
	iHover = 0

	if (_mode){
		nSysTime = GetInfo_SysTime()
		if (bAnimate){
			Launcher_DrawStart = nSysTime
		}else{
			Launcher_DrawStart = nSysTime-nAnimateTime
		}
		Launcher_Redraw = 1
	}
	return

#deffunc Launcher_Draw int _mode
/*
	`̕`
*/
	Launcher_DrawTime = nSysTime - Launcher_DrawStart
	redraw 0
	Drawing_Background 0, 0, nWidth, nHeight
	id = xLaunch(iSelect + CLI_CHILD)
	repeat nCount
		if (Launcher_DrawTime <= nAnimateTime){
			x = ax(cnt) * (Launcher_DrawTime - nAnimateTime) * (Launcher_DrawTime - nAnimateTime) + xLaunch(id + LAUNCH_X)
			y = ay(cnt) * (Launcher_DrawTime - nAnimateTime) * (Launcher_DrawTime - nAnimateTime) + xLaunch(id + LAUNCH_Y)
		}else{
			x = xLaunch(id + LAUNCH_X)
			y = xLaunch(id + LAUNCH_Y)
		}
		Drawing_Item id, x, y, 0
		if (xLaunch(id + LAUNCH_TYPE) != LAUNCH_TYPE_SEPARATOR){
			if (iRock = id){
				Drawing_BlendPattern x, y, 1
			}else:if (iHover = id){
				if (nDrag = 0){
					Drawing_BlendPattern x, y
				}else{
					Drawing_Item id, x, y, 4
				}
			}
		}
		id = xLaunch(id + CLI_NEXT)
	loop
	Drawing_Label strref(xLaunch(iSelect + LAUNCH_NAME)), xLaunch(iSelect + LAUNCH_HICON), x
	redraw 1
	Launcher_Redraw = (Launcher_DrawTime <= nAnimateTime)
	return

#deffunc Launcher_Slide int _mode
/*
	`XCh
*/
	nSysTime = GetInfo_SysTime()
	if (bAnimate){
		start = nSysTime
		if (_mode){
			if (bSide){
				x = nDispx
				xs = nDispx - nWidth
			}else{
				x = -nWidth
				xs = 0
			}
		}else{
			if (bSide){
				x = nDispx - nWidth
				xs = nDispx
			}else{
				x = 0
				xs = -nWidth
			}
		}
		ax = double(x - xs) / (nAnimateTime * nAnimateTime)
		repeat
			wait 1
			nSysTime = GetInfo_SysTime()
			time = nSysTime - start
			if (time > nAnimateTime){
				break
			}
			x = int(ax * (time - nAnimateTime) * (time - nAnimateTime) + xs)
			SetWindowPos hwnd_launcher, 0, x, 0, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE
		loop
	}
	return

#deffunc Launcher_Execute int _id, str _param
/*
	ACe̎s
*/
	if (cl_check(xLaunch, _id)){
		if (xLaunch(_id + LAUNCH_TYPE) = LAUNCH_TYPE_GROUP){
			iHover = 0
			iRock = 0
			nDrag = 0
			nSysTime = GetInfo_SysTime()
			Launcher_Reload _id, 3
		}else:if (xLaunch(_id + LAUNCH_TYPE) = LAUNCH_TYPE_LINK){
			stFile = strref(xLaunch(_id + LAUNCH_HREF))
			stPath = getpath(stFile, 32)
			stParam = strref(xLaunch(_id + LAUNCH_PARAM))
			if (_param != ""){
				stParam = _param + stParam
			}
			ShellExecute hwnd, 0, varptr(stFile), varptr(stParam), varptr(stPath), 1
			dim stFile, 1
			dim stPath, 1
			dim stParam, 1
		}
	}
	return

#deffunc Launcher_Open int _id
/*
	`J
*/
	if (_id = 0){
		return
	}else{
		if (xLaunch(_id + LAUNCH_TYPE) = LAUNCH_TYPE_LINK){
			ActivateWin hwnd_fore, hwnd_launcher
			Launcher_Execute _id, ""
			return
		}
	}
	hwnd_latest = hwnd_fore
	iSelect = _id
	iHover = 0
	iRock = 0
	nDrag = 0
	if (nLeftButton = 2){
		if (nMouseAct != 2){
			iRock = -1
			nDrag = 2
		}
	}
	SetWindowPos hwnd_launcher, -1, 0-nWidth, 0, 0, 0, SWP_NOSIZE | SWP_SHOWWINDOW
	GetForegroundWindow : hwnd_fore = stat
	ActivateWin hwnd_fore, hwnd_launcher
	gsel IDW_LAUNCHER, 2
	if (bAnimateSlide){
		Launcher_Reload iSelect
		Launcher_Draw
		Launcher_Slide 1
	}else{
		Launcher_Reload iSelect, 1
		Launcher_Draw
	}
	SetWindowPos hwnd_launcher, -1, (nDispx-nWidth)*bSide, 0, 0, 0, SWP_NOSIZE | SWP_NOZORDER
	bActive = 1
	bOpen = 1
	return

#deffunc Launcher_Close int _mode
/*
	`
*/
	bActive = 0
	Launcher_Slide 0
	Drawing_Background 0, 0, nWidth, nHeight
	SetWindowPos hwnd_launcher, 0, (nDispx+nWidth)*bSide-nWidth, 0, 0, 0, SWP_NOSIZE | SWP_HIDEWINDOW
	if (_mode){
		if (hwnd_latest){
			ActivateWin hwnd_launcher, hwnd_latest
		}
	}
	return

#deffunc Launcher_Change int _mode
/*
	`̐؂ւ
*/
	if (iSelect != iRoot){
		i = iSelect
		f = 0
		if (_mode = 1){
			f = CLI_PREV
		}else:if (_mode = 2){
			f = CLI_NEXT
		}else{
			if (xLaunch(_mode + CLI_PARENT)){
				f = CLI_PARENT
			}
		}
		if (f){
			repeat
				iSelect = xLaunch(iSelect + f)
				if (xLaunch(iSelect + LAUNCH_TYPE) = LAUNCH_TYPE_GROUP) | (i = iSelect){
					break
				}
			loop
			if (i != iSelect){
				Launcher_Reload iSelect, 1 + (_mode = 3)
			}
		}
		if (iRock > 0) & (nDrag = 0){
			nDrag = 1
		}
	}
	return

#deffunc Launcher_Control
/*
	`
*/
	if (bKeyOperate){
		if (BX - MX > 3) | (BX - MX < -3) | (BY - MY > 3) | (BY - MY < -3){
			bKeyOperate = 0
		}else{
			return
		}
	}
	i = 0
	if (hwnd_point = hwnd_launcher){
		ScreenToClient hwnd_launcher, varptr(nPoint)
		id = xLaunch(iSelect + CLI_CHILD)
		repeat nCount
			if (MX >= xLaunch(id + LAUNCH_X)) & (MX < xLaunch(id + LAUNCH_X) + nItemWidth){
				if (xLaunch(id + LAUNCH_TYPE) < LAUNCH_TYPE_SEPARATOR){
					h = nItemHeight
				}else{
					h = nSeparatorHeight
				}
				if (MY >= xLaunch(id + LAUNCH_Y)) & (MY < xLaunch(id + LAUNCH_Y) + h){
					i = id
					break
				}
			}
			id = xLaunch(id + CLI_NEXT)
		loop
	}else{
		i = 0
	}
	if (i != iHover){
		if (iRock != iHover){
			Drawing_Item iHover, xLaunch(iHover + LAUNCH_X), xLaunch(iHover + LAUNCH_Y), 1
		}
		iHover = i
		if (iRock != iHover){
			if (iRock > 0){
				nDrag = 1
			}
			if (nDrag){
				if (iHover){
					nDragPos = 1
					if (MY - xLaunch(iHover + LAUNCH_Y) > nItemHeight / 2){
						if (xLaunch(iHover + LAUNCH_TYPE) = LAUNCH_TYPE_GROUP) | (nDrag = 2){
							nDragPos = 0
						}
					}
					Drawing_Item iHover, xLaunch(iHover + LAUNCH_X), xLaunch(iHover + LAUNCH_Y), 2 + nDragPos*2
				}
			}else{
				Drawing_Item iHover, xLaunch(iHover + LAUNCH_X), xLaunch(iHover + LAUNCH_Y), 2
			}
		}
	}else{
		if (nDrag){
			if (iHover != 0) & (iHover != iRock){
				f = 1
				if (MY - xLaunch(iHover + LAUNCH_Y) > nItemHeight / 2){
					if (xLaunch(iHover + LAUNCH_TYPE) = LAUNCH_TYPE_GROUP) | (nDrag = 2){
						f = 0
					}
				}
				if (f != nDragPos){
					nDragPos = f
					Drawing_Item iHover, xLaunch(iHover + LAUNCH_X), xLaunch(iHover + LAUNCH_Y), 2 + nDragPos*2
				}
			}
		}
	}
	if (nLeftButton = 1){
		if (iHover){
			iRock = iHover
		}else{
			iRock = -1
			if (hwnd_point != hwnd_launcher){
				nDrag = 2
			}
		}
		Drawing_Item iHover, xLaunch(iHover + LAUNCH_X), xLaunch(iHover + LAUNCH_Y), 3
	}else:if (nLeftButton = 3){
		if (iRock = iHover){
			Drawing_Item iRock, xLaunch(iRock + LAUNCH_X), xLaunch(iRock + LAUNCH_Y), 2
			if (nDrag = 0){
				Launcher_Execute iRock, ""
			}
		}else{
			Drawing_Item iRock, xLaunch(iRock + LAUNCH_X), xLaunch(iRock + LAUNCH_Y), 1
			if (nDrag){
				if (iHover > 0){
					if (nDrag = 1){
						cl_move xLaunch, iRock, iHover, 1 + (nDragPos=0)
						Launcher_Reload iSelect, 4
					}
				}else{
					if (hwnd_point = hwnd_launcher){
						cl_move xLaunch, iRock, iSelect, 2 + (MY<nHeight/2)
						Launcher_Reload iSelect, 4
					}
				}
			}
		}
		iRock = 0
		nDrag = 0
	}
	return

#deffunc Launcher_Setup int _mode
/*
	`̐ݒύXKp
*/
	bgscr IDW_LAUNCHER, nWidth, nHeight, 2, (nDispx-nWidth)*bSide, 0
	title "EXLA-56FC41BA-9D8E2473-FED9CA64"
	hwnd_launcher = hwnd
	GetWindowLongA hwnd_launcher, GWL_EXSTYLE
	SetWindowLongA hwnd_launcher, GWL_EXSTYLE, stat | WS_EX_LAYERED | WS_EX_TOOLWINDOW
	SetLayeredWindowAttributes hwnd_launcher, 0, nTransLate, 2
	font sFontName, nFontSize
	DragDrop_Accept 1

	nItemWidth = nWidth
	Drawing_SetBackground nWidth, 40, nLabelHeight
	Drawing_SetBlendPattern nWidth, nItemHeight
	gsel IDW_LAUNCHER
	if (_mode){
		Launcher_Reload iSelect
		Launcher_Draw
		if (_mode = 1){
			gsel IDW_LAUNCHER, 2
		}else{
			gsel IDW_LAUNCHER, 1
			EnableWindow hwnd_launcher, 0
			gsel IDW_SETTINGS, 1
		}
	}
	return

#deffunc Launcher_SetTrayIcon
	if (nMouseAct = 0){
		f = 0
	}else{
		f = 0
		repeat 6
			f += nSideWork(cnt)
		loop
	}
	if (f = 0){
		bTrayIcon = 1
	}
	if (bTrayIcon){
		TrayIcon "EXLAUNCHER", *OnTrayEvent
	}
	return
